### Visitas al repo :)

![](https://count.ayaya.beauty/get/@:randommcserver)

---

Algun dia has querido trolear a gente en servidores randoms de minecraft? Entrar a servidores que no son tuyos y hacer lo que te plazca o simplemente ir a saludar?

Te lo dire simple, es bastante facil escanear el internet para encontrar sevidores de minecraft y aca te lo enseño :)

*Cabe destacar que necesitaras conocimientos previos de Linux y otros programas*

## Requisitos

- Un sistema operativo Linux (Tambien puede ser WSL, pero no he testeado)
- Programa **masscan**, instalacion:
	- Ubuntu/Debian: `apt install masscan`
	- Arch Linux: `pacman -S masscan`
	- Fedora: `dnf install masscan`
	- Otros sistemas Linux: https://pkgs.org/search/?q=masscan
- Paciencia, ya que se puede demorar algo de tiempo en encontrar servidores	
- Checkeador de servidores de minecraft:
	- (Totalmente opcional) **gamedig**: `npm install -g gamedig`
	- https://mcsrvstat.us/

## 1. Encontrar servidores

Una vez ya tengas **masscan** instalado en tu maquina virtual, WSL o en donde estes usando Linux; Necesitaras encontrar rangos de IPs (En caso de proveedores de internet) o unas cuantas IPs (Si los servidores de minecraft estan dentro de una misma maquina con una IP, como holy.gg) .

### 1.1 Servidores Arrendados (Ej: holy.gg)

En este ejemplo tomare los servidores de holy.gg, pero lo primero que habra que hacer es encontrar las IPs de holy.gg. Para poder hacer esto lo que hay que hacer es ingresar el dominio dentro de [DNSDumpster](https://dnsdumpster.com/), en este caso seria **holy.gg**. Y nos retornara una cantidad de dominios que apuntan a diferentes IPs que ellos tienen para sus servidores.

Dentro de la propia pagina podremos ver X dominio apunta a X ip, como en el caso de **ar.holy.gg** que apunta a la ip **45.235.99.92**. Ya teniendo la IP en nuestras manos podemos proseguir a usar el programa **masscan** para escanear los diferentes puestos de esa IP, donde los mas probable, esten servidores de usuarios de holy.gg

### 1.2 Servidores Individuales (Gente que aloja su servidor con su propio internet)

Aca necesitaras encontrar el rango de IPs de un proveedor de internet aleatorio de tu pais u otro pais si asi lo deseas, pero sera mas dificil identificar los proveedores de internet (ya que no las conoces obvio lol).

Entra a https://ipinfo.io/countries y busca tu pais, luego selecciona un proveedor de internet, y copia uno de los rangos de IPs que aparecen dentro de la lista, en este caso yo seleccione este rango de IPs de el proveedor de internet **Claro**

![caca](https://ii.zzls.xyz/TGMTSTI.png)

Y listo, ya tienes un rango de IPs listo para ser escaneado :)

## 2. Usar masscan para encontrar servidores de minecraft

Abre una terminal y dentro de ella escribe este comando: 

```bash
sudo masscan -p <puertos> <ip> --rate 1000
```

Aca hay que reemplazar *puertos* e *ip* con sus resectivos valores. En la siguente seccion explico mas a detalle dependiendo del que tipo de servidor se quiere escanear

Aparte de los puertos e ips, esta el argumento de ***--rate*** que define a cuantos puertos por segundo se escanean las ips, mientras mas bajo, mas preciso, pero mas lento, esto dependera de gran parte de tu router, tu adaptador ethernet o si estas usando wifi o no. Por eso es mejor dejarlo a 1000 o menos de 1000 para no perder paquetes y poder encontrar servidores de forma efectiva.

### 2.0.5 Aumentar la velocidad del escaneo aumentando el valor de los File Descriptors

**Si quieres escanear puertos a una mayor velocidad/efectividad, necesitaras aumentar el valor de los `file descriptors` ([¿Qué son los file descriptors?, Explicado en Ingles](https://stackoverflow.com/a/5256705/12762375)) de UNIX**

Esto se puede hacer usando el comando `ulimit -n <valor>`. Un valor recomendado para escanear `3000` puertos por segundo seria `3500`, entonces el comando que habria que ejecutar seria: `ulimit -n 3500`.

Luego de haber ejecutado ese comando, puedes empezar a aumentar el valor de `--rate` a `3000` haciendo que el comando final quede así:

```bash
sudo masscan -p 25565 186.20.0.0/16 --rate 3000
```

Obviamente esto hara que la velocidad a la que se escanean los puertos sea el **triple de rapida** a comparacion de tener el el `--rate` a `1000`

#### Q&A (Preguntas y Respuestas)

1. Porque hay que aumentar el valor de los file descriptors para poder escanear a una mayor velocidad?
   1. En UNIX (BSD y Linux) **todo es un archivo**, tomando eso en cuenta, las conexiones a internet tambien son un archivo y cada proceso abierto tiene el limite que esta asignado dentro del sistema. Entonces, por ejemplo, en algunos sistemas operativos el valor por defecto en `1024`, eso significa que el proceso solo tiene permiso a abrir `1024` archivos al mismo tiempo, y como dije anteriormente, las conexiones a internet tambien son un archivo. Si quisieramos escanear a `5000` puertos por segundo, `massscan` se vera limitado a solo escanear `1024` puertos por segundos debido al limite de archivos abiertos. Y por eso hay que aumentarlo :)

2. Entonces podria escanear a `30000` puertos por segundo si uso el comando `ulimit -n 30000`?
   1. No. Claro que `masscan` podra abrir la cantidad de archivos necesaria para poder escanear `30000` puertos por segundo, pero el problema principal ahi seria el hardware que uno tiene. No todas las tarjetas Ethernet/Wifi soportan tantos paquetes por segundo, y en esto tambien se incluye el Router, si tu router no es capaz de enviar y recibir una gran cantidad de paquetes, no funcionara. Usar el valor de `30000` solo llevara a perdida de paquetes y que no puedas encontrar ningun puerto abierto.

![xd](https://ii.zzls.xyz/EQHANQI.png)

### 2.1 Masscan en Servidores arrendados

Abre una terminal y dentro de ella escribe este comando: 

```bash
sudo masscan -p 10000-65535 45.235.99.92 --rate 1000
```

Lo que va a hacer este comando, sera encontrar si hay puertos abiertos dentro del rango **10000** y **65535** de la ip **45.235.99.92** que mencione en la seccion ***1.1***.

### 2.2 Masscan en servidores individuales

Usa este comando: 

```bash
sudo masscan -p 25565 186.20.0.0/16 --rate 1000
```

 Este comando buscara si el puerto **25565** (el puerto por defecto de minecraft) esta abierto dentro de las diferentes IPs que se definen dentro del rango de IPs ingresado (**186.20.0.0/16**)


## 3. Checkear los servidores

Si ya conseguiste ips con los puertos abiertos, ahora tendras que checkearlos para ver si son realmente servidores de minecraft o son otra cosa a parte de minecraft.

### 3.1 Usando [mcsrvstatus](https://mcsrvstat.us/)

Entra a [mcsrvstatus](https://mcsrvstat.us/) e ingresa la IP con su respectivo puerto:

![](https://ii.zzls.xyz/TCIHOCI.png)

### 3.2 Usando gamedig (Si lo instalaste) 

`gamedig --type minecraft <ip><puerto> | jq`


## 4. Final

lol, eso xdxdkuasdghjadgshdjgasdhjkasdgsadjhkgsadjhasdgasjdgsadhjadghjas ahora a trolear y llenar los servers de paredes de lava 

![](https://ii.zzls.xyz/ONASPII.png)
![](https://ii.zzls.xyz/AHYXAII.png)